## opencl-clang-18 18.1.1

=== debian/changelog ===
opencl-clang-18 (18.1.1-2) unstable; urgency=medium

  * Merge changes from opencl-clang-17 17.0.1-2.
  * Build with g++-14.  (Closes: #1097515)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 09 Sep 2025 11:58:35 +0200

opencl-clang-18 (18.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-17 17.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Dec 2024 09:30:56 +0100

opencl-clang-18 (18.1.0-2) unstable; urgency=medium

  * Restrict watch file to 18.* releases.
  * Bump Standards-Version to 4.7.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 21 Sep 2024 00:45:33 +0200

opencl-clang-17 (17.0.1-2) unstable; urgency=medium

  * Merge changes from opencl-clang-16 16.0.4-1.
  * Build with g++-14.  (Closes: #1097514)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 07 Sep 2025 22:56:11 +0200

opencl-clang-17 (17.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-16 16.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Dec 2024 00:09:32 +0100

opencl-clang-16 (16.0.4-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.3-1.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Sep 2025 11:47:15 +0200

opencl-clang-16 (16.0.3-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.2-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 09:27:05 +0200

opencl-clang-16 (16.0.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 12:25:46 +0100

opencl-clang-15 (15.0.3-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.2-3.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Sep 2025 23:41:19 +0200

opencl-clang-15 (15.0.2-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.2-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 09:16:36 +0200

opencl-clang-15 (15.0.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 12:10:48 +0100

opencl-clang-14 (14.0.2-3) unstable; urgency=medium

  * Build with g++-14.  (Closes: #1114244)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 06 Sep 2025 08:45:50 +0200

opencl-clang-14 (14.0.2-2) unstable; urgency=medium

  * Fix building with CMake 4.  (Closes: #1113353)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Sep 2025 23:30:16 +0200

opencl-clang-14 (14.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Aug 2025 14:10:32 +0200

opencl-clang-14 (14.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Bump Standards-Version to 4.7.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 01:02:54 +0100
