## opencl-clang-18 18.1.2

=== debian/changelog ===
opencl-clang-18 (18.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-17 17.0.2-1.
  * Build with g++-15.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 18 Dec 2025 00:24:05 +0100

opencl-clang-17 (17.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-16 16.0.6-1
  * Build with g++-15.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Dec 2025 10:25:49 +0100

opencl-clang-16 (16.0.6-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.5-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Dec 2025 14:46:00 +0100

opencl-clang-15 (15.0.5-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.5-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Dec 2025 06:36:57 +0100

opencl-clang-14 (14.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 14 Dec 2025 23:10:53 +0100
