=== debian/control ===
--- 
+++ 
@@ -6,18 +6,16 @@
  Timo Aaltonen <tjaalton@debian.org>,
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends: debhelper-compat (= 13),
- g++-14,
  cmake,
  libz-dev,
 # keep the clang/llvm version in sync
  clang-18,
- libclang-18-dev,
+ libclang-18-dev (>= 1:18.1.8-20~),
  libclang-cpp18-dev,
  libllvmspirvlib-18-dev,
  llvm-18-dev,
 # prevent accidental backports after the 64-bit time_t transition
  dpkg-dev (>= 1.22.5),
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/intel/opencl-clang
 Vcs-Browser: https://salsa.debian.org/opencl-team/opencl-clang
